<!DOCTYPE html>

<html>

<head>
    <title>Web app</title>

    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">

    <style>
        .bordered {
            border-width: thin;
            border-color: rgba(0, 0, 0, 0.151);
            border-style: solid;
            border-radius: 10px;
        }

        .node-container {
            display: block;
            margin: 2px;
            padding: 5px;
        }

        .node-name {
            font-size: 20px;
        }

        .node-description {
            font-size: 15px;
        }

        div.node-children-container {
            margin-left: 2%;
        }

        div.attribute-row {
            display: flex;
            justify-content: space-between;
        }

        div.attribute-container {
            background-color: #00000033;
            display: inline-block;
            padding: 10px;
            min-width: 300px;
            margin-top: 5px;
            margin-bottom: 5px;
        }

        .attribute-value {
            color: green;
            display: inline-block;
            min-height: 1rem;
            min-width: 50px;
            text-align: end;
        }

        input.attribute-value-edit {
            display: inline;
            width: 6rem;
        }

        input.attribute-value-slider {
            width: 10rem;
        }

        .attribute-value-undefined {
            color: rgba(0, 0, 0, 0.397)
        }

        .node-error {
            background-color: rgba(255, 0, 0, 0.068);
        }

        .animation-loading {
            height: 60px;
        }

        div.user-permission {
            margin-left: 10px;
            color: #00000077;
        }

        div.node-container:has(> div#node-children.show) > div > button > span#button-plus {
            display: none
        }

        div.node-container:has(> div#node-children:not(.show)) > div > button > span#button-plus {
            display: inline-block
        }

        div.node-container:has(> div#node-children.show) > div > button > span#button-minus {
            display: inline-block
        }

        div.node-container:has(> div#node-children:not(.show)) > div > button > span#button-minus {
            display: none
        }

        .dialog {
            display: none;
        }

        input.text-danger {
            background-color: red;
            border-color: red;
        }

        .tooltip-header {
            display: block;
            margin-top: 10px;
        }

        #button-show-hidden {
            float: right;
            height: 24px;
        }

        .loading-popup {
            display: flex;
            position: fixed;
            right: 2%;
            top: 5%;
            padding: 30px;
            background-color: white;
            border-style: solid;
            border-width: 1px;
            border-color: rgba(0, 0, 0, 0.1);
            border-radius: 20px;
        }

        .indicators-container {
            float: right;
            display: flex;
            align-items: center;
            height: 38px;
            gap: 10px
        }

        div:has(> div#node-children:empty) > div > button#button-toggle-children {
            display: none;
        }

        @keyframes notification-grey {
            0% {
                background-color: transparent;
            }

            50% {
                background-color: #00000033;
            }

            100% {
                background-color: transparent;
            }
        }

        @keyframes notification-green {
            0% {
                background-color: #00000000;
            }

            50% {
                background-color: #00ff0033;
            }

            100% {
                background-color: #00000000;
            }
        }

        @keyframes notification-red {
            0% {
                background-color: #00000000;
            }

            50% {
                background-color: #ff000033;
            }

            100% {
                background-color: #00000000;
            }
        }
    </style>

    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
    <link rel="stylesheet" href="//code.jquery.com/ui/1.13.2/themes/base/jquery-ui.css">
    <link rel="stylesheet"
        href="https://cdnjs.cloudflare.com/ajax/libs/jquery-contextmenu/2.7.1/jquery.contextMenu.min.css">

</head>

<body>
    <div id="node-container-main">
    </div>

    <template id="node-template">
        <div class="node-container bordered">
            <div id="node-without-children">
                <div>
                    <span class="node-name" id="node-name">Parent node</span>&nbsp;
                    <span class="float-end text-secondary d-none d-sm-block" id="node-id"></span>
                </div>
                <span class="node-description" id="node-description">Shit, you should not see this</span>
                <div id="attribute-container">
                    <div class="attribute-container bordered">
                        <div>
                            <span class="fst-italic fw-light">Attributes</span>
                            <span class="fst-italic fw-light" style="display:none" id="attributes-copy-comment">-
                                copied</span>
                            <img id="button-show-hidden"
                                src="https://img.icons8.com/external-compact-zufarizal-robiyanto/32/external-hidden-compact-ui-essential-vol2-compact-zufarizal-robiyanto.png"
                                alt="external-hidden-compact-ui-essential-vol2-compact-zufarizal-robiyanto" />

                        </div>
                        <div class="d-inline" id="attributes-container"></div>
                    </div>
                </div>
            </div>
            <div>
                <button class="btn btn-primary" id="button-toggle-children" type="button">
                    <span id="button-plus" class="ui-icon ui-icon-plus"></span>
                    <span id="button-minus" class="ui-icon ui-icon-minus"></span>
                    Children
                </button>
                <div class="indicators-container">
                    <img style="display: none" id="filter-ok" title="Filter expression applied" height="20px" src="img/filtered-green.png">
                    <img style="display: none" id="filter-error" height="20px" src="img/filtered-red.png">

                    <img style="display: none" id="sort-ok" title="Sorting expression applied" height="20px" src="img/sorted-green.png">
                    <img style="display: none" id="sort-error" title="Sorting expression error" height="20px" src="img/sorted-red.png">
                </div>
            </div>
            <div class="collapse node-children-container" id="node-children"></div>
        </div>
    </template>

    <template id="attribute-row-template">
        <div class="attribute-row">
            <div id="attribute-name"></div>

            <div>
                <div style="display:none" class="form-check form-switch" id="attribute-value-checkbox"
                    data-value-type="boolean">
                    <input class="form-check-input" type="checkbox" role="switch">
                </div>

                <input style="display:none" id="attribute-value-slider" class="form-range attribute-value-slider"
                    type="range" min="0" max="100">

                <span class="attribute-value" id="attribute-value"></span>
                <input type="text" class="form-control attribute-value-edit">
            </div>

        </div>
    </template>

    <template id="attribute-template">
        <div>
            <div class="d-inline" id="attribute-name">Attribute name</div>&nbsp;
            <div class="d-inline float-end">
                <div class="d-inline text-secondary" id="attribute-id">attribute_id</div>
                <span id="btn-up" class="ui-icon ui-icon-arrowthick-1-n"></span>
                <span id="btn-down" class="ui-icon ui-icon-arrowthick-1-s"></span>
                <span id="btn-edit" class="ui-icon ui-icon-pencil"></span>
                <span id="btn-delete" class="ui-icon ui-icon-trash"></span>
            </div>
        </div>
    </template>

    <div id="dialog-edit-node" class="dialog">
        <div class="form-group">
            <label for="input-node-name">Node name</label>
            <input type="text" id="input-node-name" class="form-control">
        </div>
        <div class="form-group">
            <label for="input-node-description">Node description</label>
            <input type="text" id="input-node-description" class="form-control">
        </div>
        <div class="form-group">
            <label for="input-node-sort">Sorting expression</label>
            <input type="text" id="input-node-sort" class="form-control">
            <span id="hint-sort" class="fw-lighter fst-italic text-success"></span>
        </div>
        <div class="form-group">
            <label for="input-node-filter">Filter expression</label>
            <input type="text" id="input-node-filter" class="form-control">
            <span id="hint-filter" class="fw-lighter fst-italic text-success"></span>
        </div>

        <div class="form-group" id="node-edit-attributes-container">
            <div>
                <label for="input-node-attributes">Attributes</label>
                <span id="button-attribute-add" class="ui-icon ui-icon-plus"></span>
            </div>
            <div id="container-attributes">
            </div>
        </div>
    </div>

    <div id="dialog-waiting-refresh" title="Waiting for confirmation" class="dialog">
        <img class="animation-loading" src="img/loading.gif">
        Waiting for server
    </div>

    <div id="dialog-error" title="Error" class="dialog">
        <h2>An error occured</h2>
        <button data-bs-toggle="collapse" class="btn btn-secondary" data-bs-target="#dialog-error #text-error">Show
            details</button>
        <div id="text-error" class="collapse"></div>
    </div>

    <div id="dialog-attribute-edit" title="Edit attribute" class="dialog">
        <div class="form-group">
            <label for="attribute-type">Type</label>
            <select id="attribute-type" data-property-key="value_type" class="form-select">
                <option value="none">None / Text</option>
                <option value="integer">Integer</option>
                <option value="boolean">Boolean</option>
            </select>
            <div class="w-100 mt-1 mb-1" id="attribute-range">
                <div class="d-inline-block w-50"><input data-property-key="range.min" placeholder="min"
                        class="form-control" type="number"></div>
                <div class="d-inline-block w-50 float-end"><input data-property-key="range.max" placeholder="max"
                        class="form-control" type="number"></div>
            </div>
        </div>
        <div class="form-group mb-3">
            <label for="attribute-id">ID</label>
            <input class="form-control" type="text" data-property-key="id" id="attribute-id">
        </div>
        <div class="form-group mb-3">
            <label for="attribute-name">Name</label>
            <input class="form-control" type="text" data-property-key="label" id="attribute-name">
        </div>
        <div class="form-check">
            <input class="form-check-input" type="checkbox" data-property-key="ui.read_only"
                id="input-attribute-read-only">
            <label class="form-check-label" for="input-attribute-read-only">
                Read only in UI
            </label>
        </div>
        <div class="form-check">
            <input class="form-check-input" type="checkbox" data-property-key="ui.hide" id="input-attribute-hide">
            <label class="form-check-label" for="input-attribute-hide">
                Hide in UI
            </label>
        </div>
        <div class="dropdown">
            <button class="btn btn-secondary dropdown-toggle w-100" type="button" id="field-type-selection-button"
                data-bs-toggle="dropdown" aria-expanded="false">
                Add field
            </button>
            <ul class="dropdown-menu w-100" aria-labelledby="field-type-selection-button">
                <li><a class="dropdown-item" data-attribute-field-category="filter">Filter</a></li>
                <li><a class="dropdown-item" data-attribute-field-category="validation">Validation</a></li>
                <li><a class="dropdown-item" data-attribute-field-category="transformation">Transformation</a>
                </li>
                <li><a class="dropdown-item" data-attribute-field-category="transformation_display">Display
                        transformation</a></li>
                <li><a class="dropdown-item" data-attribute-field-category="custom">Custom field</a></li>
            </ul>
        </div>
        <template id="template-attribute-field">
            <div class="form-group mb-3">
                <input class="form-control" type="text">
                <span id="hint-filter" class="fw-lighter fst-italic text-success"></span>
            </div>
        </template>
        <div data-attribute-field-category="filter">
            <p class="fw-bold">Filters</p>
            <div id="attribute-field-container"></div>
        </div>
        <div data-attribute-field-category="validation">
            <p class="fw-bold">Validations</p>
            <div id="attribute-field-container"></div>
        </div>
        <div data-attribute-field-category="transformation">
            <p class="fw-bold">Transformations</p>
            <div id="attribute-field-container"></div>
        </div>
        <div data-attribute-field-category="transformation_display">
            <p class="fw-bold">Display transformations</p>
            <div id="attribute-field-container"></div>
        </div>
        <div data-attribute-field-category="custom">
            <p class="fw-bold">Custom fields</p>
            <div id="attribute-field-container"></div>
        </div>
    </div>

    <div id="dialog-accounts" title="Manage accounts / API keys" class="dialog">
        <div>
            <h4 class="d-inline">Accounts</h4>
            <span id="button-account-add" class="ui-icon ui-icon-plus float-end"></span>
            <div id="accounts-container">
            </div>
            <div id="account-template" class="d-none">
                <span id="account-type">Invitation</span>
                <span id="account-username"></span>
                <span class="text-secondary" id="account-label"></span>
                <div class="d-inline float-end">
                    <span class="ui-icon ui-icon-clipboard"></span>
                    <span class="ui-icon ui-icon-trash"></span>
                </div>
                <div id="account-permissions">
                </div>
            </div>
        </div>
    </div>

    <div id="dialog-account-edit" title="Add account" class="dialog">
        <h4>Type</h4>
        <select class="form-select" id="account-type-select" data-property-key="type">
            <option value="invitation" selected>User Invitation</option>
            <option value="link" selected>Authenticated link</option>
            <option value="api-token">API Token</option>
        </select>
        <h4>Label</h4>
        <input class="form-control" type="text" id="account-label" data-property-key="label">
        <h4>Permissions</h4>
        <div class="form-group">
            <div id="permission-children">
                <input type="checkbox" data-property-key="children">
                <span>Extend permissions to children</span>
            </div>
            <div id="permission-node-read">
                <input type="checkbox" data-property-key="node_read">
                <span>Read node</span>
            </div>
            <div id="permission-node-write">
                <input type="checkbox" data-property-key="node_write">
                <span>Write node</span>
            </div>
            <div id="permission-attributes-read">
                <input type="checkbox" data-property-key="attributes_read">
                <span>Read node attributes</span>
            </div>
            <div id="permission-attributes-write">
                <input type="checkbox" data-property-key="attributes_write">
                <span>Write node attributes</span>
            </div>
            <div id="permission-accounts">
                <input type="checkbox" data-property-key="accounts">
                <span>Create accounts and API keys</span>
            </div>
        </div>
    </div>

    <div class="modal fade" id="dialog-node-delete" tabindex="-1" role="dialog" aria-labelledby="nodeDeletionModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="nodeDeletionModalLabel">Deletion confirmation</h5>
              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
              <div>Are you sure to delete node "<span id="node-name"></span>"?</div>
              <div id="clone-warning"></div>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cancel</button>
              <button type="button" class="btn btn-danger" id="confirm" data-bs-dismiss="modal">Delete</button>
            </div>
          </div>
        </div>
      </div>

    <div id="loading-popup" class="loading-popup align-items-center">
        <div class="spinner-border ms-auto" role="status" aria-hidden="true"></div>
        <strong class="ms-3">Loading...</strong>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/jsonata/jsonata.min.js"></script>
    <script src="https://code.jquery.com/jquery-3.6.2.js"></script>
    <script src="https://code.jquery.com/ui/1.13.2/jquery-ui.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-contextmenu/2.7.1/jquery.contextMenu.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-contextmenu/2.7.1/jquery.ui.position.js"></script>
    <script src="https://rawgit.com/notifyjs/notifyjs/master/dist/notify.js"></script>
    <script src="/api/socket.io/socket.io.js"></script>

    <script type="module" src="js/app.js"></script>
</body>

</html>
